class Btn extends MovieClip
{
   var onRollOver;
   var bIn;
   var bGray;
   var onDragOut;
   var onRollOut;
   var onPress;
   var bDown;
   var onReleaseOutside;
   var onRelease;
   var __bGray;
   var __sTxt;
   var tTxt;
   var mAni;
   static var nDw;
   static var nBorder = 10;
   var autoSize = "left";
   var bAni = true;
   var bMask = false;
   function Btn()
   {
      super();
      this.onRollOver = function()
      {
         this.bIn = true;
         this.replace();
         this.rollOver(this.bGray);
      };
      this.onDragOut = this.onRollOut = function()
      {
         this.bIn = false;
         this.replace();
      };
      this.onPress = function()
      {
         this.bDown = true;
         this.replace();
         this.press(this.bGray);
      };
      this.onReleaseOutside = this.onRelease = function()
      {
         this.bDown = false;
         this.replace();
         this.release(this.bGray);
      };
   }
   function get bGray()
   {
      return this.__bGray;
   }
   function set bGray(_bGray)
   {
      if(this.__bGray != _bGray)
      {
         this.__bGray = _bGray;
         Btn.gray(this,this.__bGray);
      }
   }
   function get sTxt()
   {
      return this.__sTxt;
   }
   function set sTxt(_sTxt)
   {
      this.__sTxt = _sTxt;
      this.replace();
   }
   function init(_sTxt)
   {
      this.bGray = this.bGray;
      if(_sTxt != "undefined")
      {
         this.sTxt = _sTxt;
      }
      this.hitArea = this.tTxt;
      this.replace();
   }
   function replace()
   {
      var _loc2_ = undefined;
      if(this.bIn && this.bDown)
      {
         _loc2_ = "Down";
      }
      else if(this.bIn || this.bDown)
      {
         _loc2_ = "Over";
      }
      else
      {
         _loc2_ = "Up";
      }
      this.gotoAndStop(_loc2_);
      this.mAni.gotoAndStop(_loc2_);
      this.tTxt.autoSize = true;
      if(this.autoSize == "right")
      {
         this.tTxt._x = - int(this.tTxt._width);
      }
      else if(this.autoSize == "center")
      {
         this.tTxt._x = - int(this.tTxt._width / 2);
      }
      else
      {
         this.tTxt._x = 0;
      }
      if(!this.bAni)
      {
         this.mAni._visible = false;
      }
      else
      {
         if(isNaN(Btn.nDw))
         {
            Btn.nDw = int(this.tTxt._width - this.tTxt.textWidth);
         }
         this.mAni._x = this.tTxt._x + Btn.nDw - Btn.nBorder;
         if(this.bMask)
         {
            this.mAni.setMask(this.tTxt);
         }
      }
   }
   static function gray(_m, _b)
   {
      if(_b)
      {
         _m.filters = [new flash.filters.ColorMatrixFilter([0.308600038290024,0.609399974346161,0.0820000022649765,0,0,0.308600008487701,0.609399974346161,0.0820000022649765,0,0,0.308600008487701,0.609399974346161,0.0820000246167183,0,0,0,0,0,1,0])];
      }
      else
      {
         _m.filters = [];
      }
   }
   function press(_b)
   {
   }
   function release(_b)
   {
   }
   function rollOver(_b)
   {
   }
}
